From 4fa1f96e09f1d7fdcaf3d1a7bb959a7ddd43bf61 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 723/1001] Convert the linechart widget


---

diff --git a/hubs/widgets/linechart/__init__.py b/hubs/widgets/linechart/__init__.py
new file mode 100644
index 0000000..c7ac68e
--- /dev/null
+++ b/hubs/widgets/linechart/__init__.py
@@ -0,0 +1,45 @@
+from __future__ import unicode_literals
+
+from hubs import validators
+from hubs.widgets.chrome import panel
+from hubs.widgets.base import Widget, WidgetView
+
+
+class Linechart(Widget):
+
+    name = "linechart"
+    position = "left"
+    arguments = [dict(
+        name="username",
+        label="Username",
+        default=None,
+        validator=validators.username,
+        help="A FAS username.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/linechart.html"
+    chrome = panel("Weekly Activity")
+
+    def get_context(self, instance, *args, **kwargs):
+        username = instance.config["username"]
+        categories = [
+            'git', 'Wiki', 'Copr', 'anitya', 'mirrormanager', 'ansible',
+            'fedoratagger', 'Pkgdb', 'summershum', 'nuancier', 'Mailman',
+            'fedbadges', 'FMN', 'koschei', 'compose', 'fedimg',
+            'Jenkins', 'irc', 'FAS', 'buildsys', 'Askbot', 'pagure',
+            'Bodhi', 'faf', 'kerneltest', 'github', 'Trac', 'meetbot',
+            'planet', 'fedocal', 'hotness',
+            ]
+        categories = [c.lower() for c in categories]
+        categories = "&".join(['category=%s' % c for c in categories])
+        url = ("https://apps.fedoraproject.org/datagrepper/charts/stackedline"
+               "?delta=604800&N=12&style=clean&height=300&fill=true"
+               "&user={username}&split_on=categories")
+        url = url + "&" + categories
+        url = url.format(username=username)
+        return dict(url=url)

